from InfoDialog_sol import Ui_InfoDialog
import sys
from PyQt4.QtGui import *
from PyQt4.QtCore import *


class InfoDialog(QDialog):
    def __init__(self, parent=None):
        super(InfoDialog, self).__init__(parent)
    	    
        self.ui = Ui_InfoDialog()
        self.ui.setupUi(self)
        
        self.ui.bOk.setEnabled(False)
        self.ui.leEmail.setEnabled(False)
        
        ###connections###
        self.ui.bCancel.clicked.connect(self.close)
        self.ui.bOk.clicked.connect(self.on_ok_pressed)        
        self.ui.cbSubscribe.toggled.connect(self.ui.leEmail.setEnabled)
        self.ui.cbSubscribe.toggled.connect(self.enable_ok)        
        self.ui.leName.textChanged.connect(self.enable_ok)        
        self.ui.leSurname.textChanged.connect(self.enable_ok)
        self.ui.leEmail.textChanged.connect(self.enable_ok)
        self.ui.sbAge.valueChanged.connect(self.enable_ok)
                
        
    def enable_ok(self):
        enable = ( self.ui.sbAge.value() >= 18 ) and \
                 ( not self.ui.leName.text().isEmpty() ) and \
                 ( not self.ui.leSurname.text().isEmpty() )
        
        if self.ui.cbSubscribe.isChecked():
            enable = enable and not self.ui.leEmail.text().isEmpty()
        
        self.ui.bOk.setEnabled(enable) 

    def on_ok_pressed(self):
        message = 'User registered'
        
        if self.ui.cbSubscribe.isChecked():
            message += ' and subscribed with mail: ' + self.ui.leEmail.text()
        
        QMessageBox.information(self, 'info', message)
        
        self.close()

if __name__ == '__main__':
    app = QApplication(sys.argv)
 
    main = InfoDialog()
    main.setWindowTitle('Info Dialog')
    
    main.show()
 
    sys.exit(app.exec_())
